%global serial 3
%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 1
%global version_minor 0
%global version_micro 2
%global version_release redhat_00001
%{?scl:%scl_package artemis-native} 
%{!?scl:%global pkg_name %{name}}

%bcond_with ppc64
%define reltag redhat_1
%define namedreltag -redhat-1
%define namedversion %{version}%{namedreltag}

#Unsupported for EAP7
%if %without ppc64
ExcludeArch: ppc64
%endif

%if 0%{?rhel} == 7
#64 bit only natives on RHEL 7
ExcludeArch: i686 i386
%endif

%define wfhomedir %{_datadir}/wildfly
%define artemisdir modules/system/layers/base/org/apache/activemq/artemis/journal/main/lib

Name:		%{?scl_prefix}artemis-native
Summary: 	Apache ActiveMQ Artemis native library, used as a bridge between Apache ActiveMQ Artemis and Linux libaio
Version: 	%{version_major}.%{version_minor}.%{version_micro}
Release:        %{serial}.%{reltag}%{?dist}
Epoch:		1
License: 	ASL 2.0
Group: 		Development/Java
URL:		http://apache.org/activemq
Requires:       libaio, glibc
BuildRequires:       activemq-artemis-native-linux-repolib

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Apache ActiveMQ Artemis distributes a native library, used as a 
bridge between Apache ActiveMQ Artemis and Linux libaio.

%package wildfly
Summary:     Apache ActiveMQ Artemis native library for EAP 7
Group:       Development
Requires:       libaio, glibc

%description wildfly
Apache ActiveMQ Artemis native library for EAP 7.

%prep

%build

%install
%{__rm} -rf %{buildroot}

%ifarch i386 i686
libdir=lib
libarch=32
archdir=linux-i686
%endif
%ifarch ppc64
libdir=lib64
libarch=64
archdir=linux-ppc64
%endif
%ifarch x86_64
libdir=lib64
libarch=64
archdir=linux-x86_64
%endif

ls %{_sourcedir}
install -d -m 755 $RPM_BUILD_ROOT/%{_libdir}
install -d -m 755 $RPM_BUILD_ROOT/%{wfhomedir}/%{artemisdir}/$archdir
cp -L %{_root_datadir}/java/repository.jboss.com/maven2-brew/org/apache/activemq/libartemis-native-$archdir/%{namedversion}/libartemis-native-$archdir-%{namedversion}.so $RPM_BUILD_ROOT/%{_libdir}/libartemis-native-$libarch.so
cp -L %{_root_datadir}/java/repository.jboss.com/maven2-brew/org/apache/activemq/libartemis-native-$archdir/%{namedversion}/libartemis-native-$archdir-%{namedversion}.so $RPM_BUILD_ROOT/%{wfhomedir}/%{artemisdir}/$archdir/libartemis-native-$libarch.so

%clean
rm -Rf $RPM_BUILD_ROOT

%pre wildfly
# Add jboss user and group
getent group jboss >/dev/null || groupadd -f -g 185 -r jboss
if ! getent passwd jboss >/dev/null ; then
    if ! getent passwd 185 >/dev/null ; then
      useradd -r -u 185 -g jboss -d %{wfhomedir} -s /sbin/nologin -c "JBoss" jboss
    else
      useradd -r -g jboss -d %{wfhomedir} -s /sbin/nologin -c "JBoss" jboss
    fi
fi
exit 0

%files
%defattr(-,root,root,-)
%{_libdir}/*.so

%files wildfly
%defattr(0755,root,root,0755)
%dir %{wfhomedir}/%{artemisdir}/linux*
%{wfhomedir}/%{artemisdir}/linux*/libartemis-native-*.so

%changelog
* Fri Sep 25 2020 Permaine Cheung <pcheung@redhat.com> - 1:1.0.2-3
- Fix library name to match CR2 zip

* Wed Sep 09 2020 Permaine Cheung <pcheung@redhat.com> - 1:1.0.2-2
- Fix library name to match the zip

* Tue Aug 25 2020 Permaine Cheung <pcheung@redhat.com> - 1:1.0.2-1
- 1.0.2-redhat-1

* Thu Jun 27 2019 Permaine Cheung <pcheung@redhat.com> - 1:1.0.0-1
- 1.0.0_00003

* Tue Mar 19 2019 Permaine Cheung <pcheung@redhat.com> - 2.6.3-13
- 2.6.3.redhat-00020

* Fri Mar 09 2019 Permaine Cheung <pcheung@redhat.com> - 2.6.3-12
- 2.6.3.redhat-00017

* Thu Feb 28 2019 Permaine Cheung <pcheung@redhat.com> - 2.6.3-11
- 2.6.3.redhat-00017

* Fri Nov 30 2018 Permaine Cheung <pcheung@redhat.com> - 2.6.3-10
- 2.6.3.redhat-00014

* Wed Oct 24 2018 Permaine Cheung <pcheung@redhat.com> - 2.6.3-7
- Rebuild for 7.2.0

* Tue Jul 10 2018 Permaine Cheung <pcheung@redhat.com> - 1.5.0-6
- Rebuild for 7.2.0

* Fri Aug 04 2017 Permaine Cheung <pcheung@redhat.com> - 1.5.0-5
- Fix for JBEAP-12428 (Unify permission for natives)

* Tue Jul 11 2017 Permaine Cheung <pcheung@redhat.com> - 1.5.0-5
- Fix for JBEAP-12428 (Unify permission for natives)

* Mon Jul 10 2017 Permaine Cheung <pcheung@redhat.com> - 1.5.0-4
- Fix for JBEAP-11922

* Fri Mar 24 2017 Permaine Cheung <pcheung@redhat.com> - 0:1.5.0-3.redhat_1
- Fix directory for wildfly subpackage in 7.1

* Fri Feb 19 2016 Permaine Cheung <pcheung@redhat.com> - 0:1.1.0-10.redhat_4
- Do not own dirs owned by eap7-wildfly

* Thu Jan 28 2016 Permaine Cheung <pcheung@redhat.com> - 0:1.1.0-9.redhat_4
- sync with version 1.1.0.wildfly-011 

* Thu Jan 21 2016 Permaine Cheung <pcheung@redhat.com> - 0:1.1.0-8.redhat_3
- Rebuild as arched packages to avoid rpmdiff and TPS waiving (JBEAP-2489)

* Fri Jan 15 2016 Permaine Cheung <pcheung@redhat.com> - 1.1-1.0.4.redhat_3.ep7.el6
- Rewrap

* Fri Jan 15 2016 Permaine Cheung <pcheung@redhat.com> - 1.1-1.0.4.redhat_3.ep7.el6
- Make this an arched wrapper

* Tue Jan 05 2016 Permaine Cheung <pcheung@redhat.com> - 1.1-1.0.4.redhat_3.ep7.el6
- sync with version 1.1.0.wildfly-010

* Tue Jan 05 2016 Petr Sakar <psakar@redhat.com> - 1.1-1.0.2.redhat_2.ep7.el6
- Upgrade to 1.1.0.redhat-3

* Fri Dec 18 2015 Permaine Cheung <pcheung@redhat.com> - 1.1-1.0.2.redhat_2.ep7.el6
- Add R: libaio, glibc

* Fri Dec 18 2015 Permaine Cheung <pcheung@redhat.com> - 1.1-1.0.2.redhat_2.ep7.el6
- Add R: libaio, glibc

* Thu Dec 10 2015 Permaine Cheung <pcheung@redhat.com> - 1.1-1.0.2.redhat_2.ep7.el6
- Wrap latest artemis-native-linux-1.1.0-2.redhat_2.ep7.el6

* Thu Dec 10 2015 Permaine Cheung <pcheung@redhat.com> - 1.1-1.0.2.redhat_2.ep7.el6
- Wrap latest artemis-native-linux-1.1.0-2.redhat_2.ep7.el6

* Wed Oct 07 2015 Permaine Cheung <pcheung@redhat.com> - 1.1-1.0.2.redhat_1.ep7.el6
- Make this a noarch build and wrap both artifacts

* Wed Oct 07 2015 Permaine Cheung <pcheung@redhat.com> - 1.1-1.0.2.redhat_1.ep7.el6
- Make this a noarch build and wrap both artifacts

* Wed Oct 07 2015 Permaine Cheung <pcheung@redhat.com> - 1.1-1.0.2.redhat_1.ep7.el6
- Make this a noarch build and wrap both artifacts

* Wed Oct 07 2015 Permaine Cheung <pcheung@redhat.com> - 1.1-1.0.2.redhat_1.ep7.el6
- 1.1.0

* Mon Sep 28 2015  Permaine Cheung <pcheung@redhat.com> 0:1.1.0-1_redhat_1
- 1.1.0
- Make this a wrapper build (wraps artemis-native-linux)

* Mon Aug 17 2015  Permaine Cheung <pcheung@redhat.com> 0:1.0.0-3_redhat_1
- Copy library instead of symlinking (similar to EAP 6)

* Mon Aug 17 2015  Permaine Cheung <pcheung@redhat.com> 0:1.0.0-2_redhat_1
- Add wildfly subpackage to avoid conflicting with activemq-artemis subpackage

* Thu Aug 13 2015  Permaine Cheung <pcheung@redhat.com> 0:1.0.0-1_redhat_1
- EAP 7 build
